require 'json'
require 'rest-client'

# Version
require 'xfers/version'

# API operations
require 'xfers/api_operations'

# Resources
require 'xfers/user'
require 'xfers/payout'
require 'xfers/intent'
require 'xfers/connect'
require 'xfers/charge'
require 'xfers/bank_account'
require 'xfers/card'


# Errors
require 'xfers/errors/xfers_error'
require 'xfers/errors/internal_server_error'
require 'xfers/errors/invalid_request_error'
require 'xfers/errors/authentication_error'

module Xfers

  SG_SANDBOX_BASE = 'https://sandbox.xfers.io/api/v3'
  SG_PRODUCTION_BASE = 'https://www.xfers.io/api/v3'
  ID_SANDBOX_BASE = 'https://sandbox-id.xfers.com/api/v3'
  ID_PRODUCTION_BASE = 'https://id.xfers.com/api/v3'

  @@api_key = ''
  @@api_base = ''

  def self.set_sg_sandbox
    @@api_base = SG_SANDBOX_BASE
  end

  def self.set_sg_production
    @@api_base = SG_PRODUCTION_BASE
  end

  def self.set_id_sandbox
    @@api_base = ID_SANDBOX_BASE
  end

  def self.set_id_production
    @@api_base = ID_PRODUCTION_BASE
  end

  def self.set_api_key(api_key)
    @@api_key = api_key
  end

  def self.get_api_key
    @@api_key
  end

  def self.get_api_base
    @@api_base
  end

end