module Xfers
  module BankAccount
    RESOUCE_URL = '/user/bank_account'


    def self.list_all(connect_key=nil)
      Xfers::APIOperations.get(nil, RESOUCE_URL, connect_key)
    end

    def self.add(params, connect_key=nil)
      raise InvalidRequestError.new 'Params cannot be empty', 400 if params.nil? or params == ''
      params['redirect'] = 'false'
      Xfers::APIOperations.post params, RESOUCE_URL, connect_key
    end

    def self.update(bank_account_id, params, connect_key=nil)
      raise InvalidRequestError.new 'BankAccount id cannot be empty', 400 if bank_account_id.nil? or bank_account_id == ''
      Xfers::APIOperations.put params, "#{RESOUCE_URL}/#{bank_account_id}", connect_key
    end

    def self.delete(bank_account_id, connect_key=nil)
      raise InvalidRequestError.new 'BankAccount id cannot be empty', 400 if bank_account_id.nil? or bank_account_id == ''
      Xfers::APIOperations.delete "#{RESOUCE_URL}/#{bank_account_id}", connect_key
    end

    def self.withdraw(bank_account_id, params, connect_key=nil)
      raise InvalidRequestError.new 'BankAccount id and params cannot be empty', 400 if bank_account_id.nil? or params.nil?
      Xfers::APIOperations.post params, "#{RESOUCE_URL}/#{bank_account_id}/withdraw", connect_key
    end

    def self.withdrawal_requests(params=nil, connect_key=nil)
      Xfers::APIOperations.get(params, "#{RESOUCE_URL}/withdrawal_requests", connect_key)[:withdrawal_requests]
    end

  end
end