module Xfers
  module Card
    RESOURCE_URL = '/cards'

    def self.list_all(user_api_token)
      raise InvalidRequestError.new 'user_api_token cannot be empty', 400 if user_api_token.nil?
      url = "#{RESOURCE_URL}?user_api_token=#{user_api_token}"
      Xfers::APIOperations.get({}, url, nil)
    end

    def self.add(params)
      raise InvalidRequestError.new 'Params cannot be empty', 400 if params.nil? or params == ''
      Xfers::APIOperations.post params, RESOURCE_URL, nil
    end

    def self.delete(card_id, user_api_token)
      raise InvalidRequestError.new 'card_id id cannot be empty', 400 if card_id.nil? or card_id == ''
      raise InvalidRequestError.new 'user_api_token id cannot be empty', 400 if user_api_token.nil? or user_api_token == ''
      params = {user_api_token: user_api_token}
      Xfers::APIOperations.delete "#{RESOURCE_URL}/#{card_id}", nil, params
    end

    def self.set_default(card_id, user_api_token)
      raise InvalidRequestError.new 'card_id id cannot be empty', 400 if card_id.nil? or card_id == ''
      raise InvalidRequestError.new 'user_api_token id cannot be empty', 400 if user_api_token.nil? or user_api_token == ''
      params = {user_api_token: user_api_token}
      Xfers::APIOperations.post params, "#{RESOURCE_URL}/#{card_id}/set_default", nil
    end

    def self.charge_guest(params)
      raise InvalidRequestError.new 'Params cannot be empty', 400 if params.nil? or params == ''
      Xfers::APIOperations.post params, '/credit_card_charges/charge_card_guest', nil
    end

    def self.charge_existing(charge_id)
      raise InvalidRequestError.new 'card_id id cannot be empty', 400 if charge_id.nil? or charge_id == ''
      params = {txn_id: charge_id}

      Xfers::APIOperations.post params, '/credit_card_charges/charge_card', nil
    end

  end
end