module Xfers
  module Charge
    RESOUCE_URL = '/charges'

    def self.retrieve(charge_id, connect_key=nil)
      raise InvalidRequestError.new 'Charge id cannot be empty', 400 if charge_id.nil? or charge_id == ''
      Xfers::APIOperations.get nil, "#{RESOUCE_URL}/#{charge_id}", connect_key
    end

    def self.list_all(params=nil, connect_key=nil)
      Xfers::APIOperations.get(params, RESOUCE_URL, connect_key)
    end

    def self.create(params, connect_key=nil)
      raise InvalidRequestError.new 'Params cannot be empty', 400 if params.nil? or params == ''
      Xfers::APIOperations.post params, RESOUCE_URL, connect_key
    end

    def self.refund(charge_id, connect_key=nil)
      raise InvalidRequestError.new 'Charge id cannot be empty', 400 if charge_id.nil? or charge_id == ''
      Xfers::APIOperations.post nil, "#{RESOUCE_URL}/#{charge_id}/refunds", connect_key
    end

    def self.validate(charge_id, params, connect_key=nil)
      raise InvalidRequestError.new 'Charge id cannot be empty', 400 if charge_id.nil? or charge_id == ''
      Xfers::APIOperations.post params, "#{RESOUCE_URL}/#{charge_id}/validate", connect_key
    end

    def self.cancel(charge_id, connect_key=nil)
      raise InvalidRequestError.new 'Charge id cannot be empty', 400 if charge_id.nil? or charge_id == ''
      Xfers::APIOperations.post nil, "#{RESOUCE_URL}/#{charge_id}/cancel", connect_key
    end

    def self.authorize(charge_id, auth_code)
      raise InvalidRequestError.new 'Charge id cannot be empty', 400 if charge_id.nil? or charge_id == ''
      raise InvalidRequestError.new 'auth_code cannot be empty', 400 if auth_code.nil? or auth_code == ''
      params = {
          'auth_code'=> auth_code
      }
      Xfers::APIOperations.post params, "#{RESOUCE_URL}/#{charge_id}/authorize", nil
    end

  end
end