module Xfers
  module Intent
    RESOUCE_URL = '/intents'

    def self.retrieve(connect_key=nil)
      Xfers::APIOperations.get(nil, RESOUCE_URL, connect_key)
    end

    def self.create(params, connect_key=nil)
      raise InvalidRequestError.new 'Params cannot be empty', 400 if params.nil? or params == ''
      Xfers::APIOperations.post params, RESOUCE_URL, connect_key
    end

    def self.cancel(intent_id, connect_key=nil)
      raise InvalidRequestError.new 'Intent id cannot be empty', 400 if intent_id.nil? or intent_id == ''
      Xfers::APIOperations.post nil, "#{RESOUCE_URL}/#{intent_id}/cancel", connect_key
    end

  end
end