module Xfers
  module Payout
    RESOUCE_URL = '/payouts'

    def self.retrieve(payout_id, connect_key=nil)
      raise InvalidRequestError.new 'Payout id cannot be empty', 400 if payout_id.nil? or payout_id == ''
      Xfers::APIOperations.get nil, "#{RESOUCE_URL}/#{payout_id}", connect_key
    end

    def self.create(params, connect_key=nil)
      raise InvalidRequestError.new 'Params cannot be empty', 400 if params.nil? or params == ''
      Xfers::APIOperations.post params, RESOUCE_URL, connect_key
    end

    def self.list_all(params=nil, connect_key=nil)
      Xfers::APIOperations.get(params, RESOUCE_URL, connect_key)
    end

  end
end